Package io.vertx.rxjava3.amqp

## Class AmqpClient

- java.lang.Object
- - io.vertx.rxjava3.amqp.AmqpClient

- All Implemented Interfaces:
    `io.vertx.lang.rx.RxDelegate`

      public class AmqpClient
      extends Object
      implements io.vertx.lang.rx.RxDelegate

  AMQP Client entry point. Use this interface to create an instance of `AmqpClient` and connect to a broker and server.

  NOTE: This class has been automatically generated from the `original` non RX-ified interface using Vert.x codegen.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static io.vertx.lang.rx.TypeArg<AmqpClient>` | `__TYPE_ARG` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `AmqpClient​(AmqpClient delegate)` |
    `AmqpClient​(Object delegate)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Completable` | `close()` | Closes the client.
    `Single<AmqpConnection>` | `connect()` | Connects to the AMQP broker or router.
    `static AmqpClient` | `create​(AmqpClientOptions options)` | Creates a new instance of `AmqpClient` using an internal Vert.x instance (with default configuration) and the given AMQP client configuration.
    `static AmqpClient` | `create​(Vertx vertx, AmqpClientOptions options)` | Creates a new instance of `AmqpClient` with the given Vert.x instance and the given options.
    `Single<AmqpReceiver>` | `createReceiver​(String address)` | Creates a receiver used to consume messages from the given address.
    `Single<AmqpReceiver>` | `createReceiver​(String address, AmqpReceiverOptions receiverOptions)` | Creates a receiver used to consumer messages from the given address.
    `Single<AmqpSender>` | `createSender​(String address)` | Creates a sender used to send messages to the given address.
    `Single<AmqpSender>` | `createSender​(String address, AmqpSenderOptions options)` | Creates a sender used to send messages to the given address.
    `boolean` | `equals​(Object o)` |
    `AmqpClient` | `getDelegate()` |
    `int` | `hashCode()` |
    `static AmqpClient` | `newInstance​(AmqpClient arg)` |
    `Completable` | `rxClose()` | Closes the client.
    `Single<AmqpConnection>` | `rxConnect()` | Connects to the AMQP broker or router.
    `Single<AmqpReceiver>` | `rxCreateReceiver​(String address)` | Creates a receiver used to consume messages from the given address.
    `Single<AmqpReceiver>` | `rxCreateReceiver​(String address, AmqpReceiverOptions receiverOptions)` | Creates a receiver used to consumer messages from the given address.
    `Single<AmqpSender>` | `rxCreateSender​(String address)` | Creates a sender used to send messages to the given address.
    `Single<AmqpSender>` | `rxCreateSender​(String address, AmqpSenderOptions options)` | Creates a sender used to send messages to the given address.
    `String` | `toString()` |

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### __TYPE_ARG

          public static final io.vertx.lang.rx.TypeArg<AmqpClient> __TYPE_ARG

  - ### Constructor Detail

    - #### AmqpClient

          public AmqpClient​(AmqpClient delegate)

    - #### AmqpClient

          public AmqpClient​(Object delegate)

  - ### Method Detail

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### equals

          public boolean equals​(Object o)

      Overrides:
        `equals` in class `Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### getDelegate

          public AmqpClient getDelegate()

      Specified by:
        `getDelegate` in interface `io.vertx.lang.rx.RxDelegate`

    - #### create

          public static AmqpClient create​(AmqpClientOptions options)

      Creates a new instance of `AmqpClient` using an internal Vert.x instance (with default configuration) and the given AMQP client configuration. Note that the created Vert.x instance will be closed when the client is closed.
      Parameters:
        `options` - the AMQP client options, may be `null` falling back to the default configuration
      Returns:
        the created instances.

    - #### create

          public static AmqpClient create​(Vertx vertx,
                                          AmqpClientOptions options)

      Creates a new instance of `AmqpClient` with the given Vert.x instance and the given options.
      Parameters:
        `vertx` - the vert.x instance, must not be `null`
        `options` - the AMQP options, may be @{code null} falling back to the default configuration
      Returns:
        the AMQP client instance

    - #### connect

          public Single<AmqpConnection> connect()

      Connects to the AMQP broker or router. The location is specified in the `AmqpClientOptions` as well as the potential credential required.
      Returns:
        a future notified with the result, giving either the connection or failure cause. Must not be `null`.

    - #### rxConnect

          public Single<AmqpConnection> rxConnect()

      Connects to the AMQP broker or router. The location is specified in the `AmqpClientOptions` as well as the potential credential required.
      Returns:
        a future notified with the result, giving either the connection or failure cause. Must not be `null`.

    - #### close

          public Completable close()

      Closes the client. The client must always be closed once not needed anymore.
      Returns:
        a future notified when the operation completes

    - #### rxClose

          public Completable rxClose()

      Closes the client. The client must always be closed once not needed anymore.
      Returns:
        a future notified when the operation completes

    - #### createReceiver

          public Single<AmqpReceiver> createReceiver​(String address)

      Creates a receiver used to consume messages from the given address. The receiver has no handler and won't start receiving messages until a handler is explicitly configured. This method avoids having to connect explicitly. You can retrieve the connection using `AmqpReceiver.connection()`.
      Parameters:
        `address` - The source address to attach the consumer to, must not be `null`
      Returns:
        a future notified with the receiver. The receiver has been opened.

    - #### rxCreateReceiver

          public Single<AmqpReceiver> rxCreateReceiver​(String address)

      Creates a receiver used to consume messages from the given address. The receiver has no handler and won't start receiving messages until a handler is explicitly configured. This method avoids having to connect explicitly. You can retrieve the connection using `AmqpReceiver.connection()`.
      Parameters:
        `address` - The source address to attach the consumer to, must not be `null`
      Returns:
        a future notified with the receiver. The receiver has been opened.

    - #### createReceiver

          public Single<AmqpReceiver> createReceiver​(String address,
                                                     AmqpReceiverOptions receiverOptions)

      Creates a receiver used to consumer messages from the given address. This method avoids having to connect explicitly. You can retrieve the connection using `AmqpReceiver.connection()`.
      Parameters:
        `address` - The source address to attach the consumer to.
        `receiverOptions` - The options for this receiver.
      Returns:
        a future notified with the receiver, once opened. Note that the `messageHandler` can be called before the `completionHandler` if messages are awaiting delivery.

    - #### rxCreateReceiver

          public Single<AmqpReceiver> rxCreateReceiver​(String address,
                                                       AmqpReceiverOptions receiverOptions)

      Creates a receiver used to consumer messages from the given address. This method avoids having to connect explicitly. You can retrieve the connection using `AmqpReceiver.connection()`.
      Parameters:
        `address` - The source address to attach the consumer to.
        `receiverOptions` - The options for this receiver.
      Returns:
        a future notified with the receiver, once opened. Note that the `messageHandler` can be called before the `completionHandler` if messages are awaiting delivery.

    - #### createSender

          public Single<AmqpSender> createSender​(String address)

      Creates a sender used to send messages to the given address. The address must be set.
      Parameters:
        `address` - The target address to attach to, must not be `null`
      Returns:
        a future notified with the sender, once opened

    - #### rxCreateSender

          public Single<AmqpSender> rxCreateSender​(String address)

      Creates a sender used to send messages to the given address. The address must be set.
      Parameters:
        `address` - The target address to attach to, must not be `null`
      Returns:
        a future notified with the sender, once opened

    - #### createSender

          public Single<AmqpSender> createSender​(String address,
                                                 AmqpSenderOptions options)

      Creates a sender used to send messages to the given address. The address must be set.
      Parameters:
        `address` - The target address to attach to, must not be `null`
        `options` - The options for this sender.
      Returns:
        a future notified with the sender, once opened

    - #### rxCreateSender

          public Single<AmqpSender> rxCreateSender​(String address,
                                                   AmqpSenderOptions options)

      Creates a sender used to send messages to the given address. The address must be set.
      Parameters:
        `address` - The target address to attach to, must not be `null`
        `options` - The options for this sender.
      Returns:
        a future notified with the sender, once opened

    - #### newInstance

          public static AmqpClient newInstance​(AmqpClient arg)